import BaseCurdEntry from './BaseCurdEntry'

import tagCodeApi from '@@/api/TagCodeApi'
import TagApplyState from './TagApplyState'

export default class TagCode extends BaseCurdEntry {
  orderNo

  serialNumberRange
  get formatSerialNumberRange () {
    const { serialNumberRange } = this
    return serialNumberRange ? serialNumberRange.join('-') : ''
  }

  dataTime
  get formatDataTime () {
    return new Date(this.dataTime).format('YYYY-MM-DD')
  }

  expectedReceiptDate
  get formatExpectedReceiptDate () {
    return new Date(this.expectedReceiptDate).format('YYYY-MM-DD')
  }

  providerName

  tagApplyStateId
  get tagApplyStateName () {
    const config = TagCode.$$optionData.TagApplyState
    if (config) {
      const option = config.map[this.tagApplyStateId]
      if (option) {
        return option[TagApplyState.$$nameProp]
      }
    }

    return ''
  }

  operatorName

  static get $$name () {
    return 'TagCode'
  }

  static get $$api () {
    return tagCodeApi
  }

  static $$optionTargetConfigGroup = [
    [{
      Target: TagApplyState
    }]
  ]
  static $$optionData = {}
}
